#include <stdio.h>
#include <stdlib.h>
#include "mydef.h"
#include "hello2.h"
#include "constant.h"

__global__ void hello_world(int *addr1) {
  printf("hello world from gpu!\n");
  printf("i_gpu=%d!\n",i_gpu);
  printf("i_gpu address = %p\n",&i_gpu);
  addr1=&i_gpu;
}

int main () {
  int i = 5;
  int *addr1;
  int *p_i_gpu=NULL;
  size_t size_i_gpu;
  HANDLE_ERROR(cudaMemcpyToSymbol( i_gpu, &i, sizeof(int) ));
  hello_world<<<1,1>>>(addr1);
  checkCUDAError("hello_world:");
  HANDLE_ERROR(cudaThreadSynchronize());
  printf("From CPU : i_gpu address before = %p\n",p_i_gpu);
  HANDLE_ERROR(cudaGetSymbolAddress((void**)&p_i_gpu,"i_gpu"));
  HANDLE_ERROR(cudaGetSymbolSize(&size_i_gpu,"i_gpu"));
  printf("From CPU : i_gpu address after = %p\n",p_i_gpu);
  printf("From CPU : i_gpu size = %d\n",size_i_gpu);
  printf("From CPU : addr1 = %p\n",&addr1);
  //hello2();
}
