#ifndef __MYDEF_H__
#define __MYDEF_H__
#include <stdio.h>
#include <cuda_runtime_api.h>

void checkCUDAError(const char *msg);
void HandleError( cudaError_t err,
                         const char *file,
                         int line );
#define HANDLE_ERROR( err ) (HandleError( err, __FILE__, __LINE__ ))


#define HANDLE_NULL( a ) {if (a == NULL) { \
                            printf( "Host memory failed in %s at line %d\n", \
                                    __FILE__, __LINE__ ); \
                            exit( EXIT_FAILURE );}}

#endif  // __MYDEF_H__
