#include <stdio.h>
#include "mydef.h"

//static __constant__ int i_gpu; 
static __device__ int i_gpu;

__global__ void this_kernel()
{
  printf("this: value = %d\n",i_gpu);
}

void this_init(int value, int** ip)
{
  HANDLE_ERROR(cudaMemcpyToSymbol( i_gpu, &value, sizeof(int) ));
  HANDLE_ERROR(cudaGetSymbolAddress((void**)ip,"i_gpu"));
  printf("From CPU this : i_gpu address after = %p\n",*ip);
}

void this_result()
{
  this_kernel<<<1,1>>>();
  HANDLE_ERROR(cudaThreadSynchronize());
}
